unit _13_Client_Form1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, ScktComp;

const
  WM_START_COMPUTING = WM_USER + $FA;

  //this must be same in server and client:
  NCMD_NONE          = 0; //nope
  NCMD_GET_TASK      = 1; //client want new task
  NCMD_DISCONNECTED  = 2; //user stops client
  NCMD_GOT_ONE       = 3; //prime found
  NCMD_TASK_DONE     = 4; //all numbers in task checked
  NCMD_TASK_4U       = 5; //sending task for client
  NCMD_BREAK         = 6; //server stopped
  NCMD_ALL_DONE      = 7;

  NCMD_GOT_INVALID_TASK = 8; //got invalid task, i wanna new

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Panel1: TPanel;
    Memo1: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    ProgressBar1: TProgressBar;
    Button1: TButton;
    Edit2: TEdit;
    Label4: TLabel;
    Button2: TButton;
    CS1: TClientSocket;
    Label5: TLabel;
    Label6: TLabel;
    Memo2: TMemo;
    Label7: TLabel;
    Label8: TLabel;
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CS1Connect(Sender: TObject; Socket: TCustomWinSocket);
    procedure Button2Click(Sender: TObject);
    procedure CS1Disconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure CS1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormDestroy(Sender: TObject);
    procedure CS1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  private
    { Private declarations }
    Connected : Boolean;
    procedure OnStartComputing(var Message:TMessage); message WM_START_COMPUTING;
    procedure SendSimpleCommand(cmd : byte);
    procedure SendDWCommand(cmd : byte; dw1, dw2 : dword);
    procedure SendPrimes;
    procedure SendBIG; //to flush cache
    procedure UpgradeGUI;
  public
    { Public declarations }
  end;

var
  Form1 : TForm1;
  SS    : TCustomWinSocket; //used to communicate with server

(*
  PROTOCOL DESC:
   data is sended using TClientSocket component, by proc
    CS1.Socket.SendBuf(buffer, count)

   contents of sended buffer :
    2 BYTEs      HEAD (id)
    1 BYTE       COMMAND
    2 DWORD      2x DWORD DATA
    0..X BYTE(s) DATA

*)


implementation

{$R *.DFM}

CONST MAXDATA = 1013;
      MY_ID = 1234;

type DataBuffer_t = packed record
                     id   : word;
                     cmd  : byte;
                     dw1, dw2 : dword;
                     data : packed array[0..MAXDATA] of byte;
                    end;
     DataBuffer_p = ^DataBuffer_t;

type iData_p = ^iData_t;
     iData_t = record
//this one have only server:                client : client_p;
                buf    : DataBuffer_p;
                count  : word;
               end;

var
  iData         : TList; //buffer for incomed data

  NumPrimes     : integer;

  current_task  : boolean;
  task_iFrom    : dword;
  task_iTo      : dword;

  task_position : dword;
  LastPrime     : dword;

  AllPrimes     : array [0..1000] of dword; //static array - all prime n
                                            //for current task
//

// LISTS

procedure ClearList(x:TList);
var i:integer;
begin
 if assigned(x)=false then
  exit;
 if x.count<1 then
  exit;
 for i:=0 to x.count-1 do
  if assigned(x.items[i]) then
   begin
    dispose(x.items[i]);
//    x.items[i]:=nil;
   end;
 x.clear;
end;


Function IsIP(s:string):boolean;
begin
 result:=Length(s)>=6; //for now
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Connected := false;
 iData := TList.Create;
 iData.Clear;
 Edit1Change(nil);
 current_task := false;
 task_iFrom := 0;
 task_iTo := 0;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 try
  StrToInt(edit1.text); //if there is a number, button can be enabled (no exception created)
  button1.enabled:=IsIP(Edit2.Text);
 except
  button1.enabled:=false; //or no
 end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 CS1.Port:=StrToInt(Edit1.Text);
 CS1.Address:=Edit2.Text;
 CS1.Open;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 //send notification
 SendSimpleCommand(NCMD_DISCONNECTED);
 //disconnect
 CS1.Close;
end;

procedure TForm1.UpgradeGUI;
begin
 ProgressBar1.Min:=0;
 ProgressBar1.Max:=task_iTo - task_iFrom;
 ProgressBar1.Position:=integer(task_position - task_iFrom);
end;

procedure TForm1.CS1Connect(Sender: TObject; Socket: TCustomWinSocket);
begin
 memo1.lines.add('CONNECTED');
 SS:=Socket;
 //start computing
 PostMessage(Form1.Handle, WM_START_COMPUTING, 0, 0);
end;

procedure TForm1.CS1Disconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
 Connected := false;
 memo1.lines.add('DISCONNECTED');
end;

procedure TForm1.SendSimpleCommand(cmd : byte);
var buf : DataBuffer_t;
    s   : string;
begin
 fillchar(buf, sizeof(buf), 0);
 buf.id := MY_ID;
 buf.cmd := cmd;
// CS1.Socket.sendbuf(buf,1000);
  setlength(s, 512);
 move(buf, s[1], 3);
  CS1.Socket.SendText(s);
end;

procedure TForm1.SendDWCommand(cmd : byte; dw1, dw2 : dword);
var buf : DataBuffer_t;
    s   : string;
begin
 fillchar(buf, sizeof(buf), 0);
 buf.id := MY_ID;
 buf.cmd := cmd;
 buf.dw1 := dw1;
 buf.dw2 := dw2;
// CS1.Socket.sendbuf(buf,1000);
  setlength(s, 512);
  move(buf, s[1], 11);
 CS1.Socket.SendText(s);
end;

procedure TForm1.SendPrimes;
var buf : DataBuffer_t;
    s   : string;
begin
 fillchar(buf, sizeof(buf), 0);
 buf.id := MY_ID;
 buf.cmd := NCMD_TASK_DONE;
 buf.dw1 := NumPrimes;
 buf.dw2 := 0;
 setlength(s, 11 + NumPrimes * sizeof(dword));
 move(buf, s[1], 11);
 move(AllPrimes[0], s[11], NumPrimes * sizeof(dword));
 CS1.Socket.SendText(s);
end;

procedure TForm1.SendBIG; //to flush cache
var    s   : string;
begin
 setlength(s, 1024);
 CS1.Socket.SendText(s);
end;


Function _13_IsItPrimeNum(num : dword) : boolean;
var x, start : dword;
begin
 result:=false;
 if num mod 2 = 0 then exit;
 start := Round(sqrt(num)); //we shoud test only numbers equal/below sqrt(n)
                     //because x / (sqrt(n) + z) is ever with fraction
                     // - where z >= 1, x is for variable, n is our num
 if start < num then
  inc(start);
 //now divide num by all numbers in <start,2>                      
 for x:= start downto 2 do
  begin
   if frac( num / x ) = 0 then
    exit; //if no fraction, NUM isn't prime
  end;
 result:=true;
end;

procedure TForm1.OnStartComputing(var Message:TMessage);
var i , j   : integer;
    IsPrime : boolean;

label have_task;    
begin

 memo1.lines.add('GOT WM_START_COMPUTING, so starting...');
 memo1.lines.add('');
 Repeat
  //
  memo1.lines.add('Asking server for task...');
  Label3.Caption:='Asking server for task...';
  i:=0;
  Repeat
   if i mod 1000 = 0 then
    SendSimpleCommand(NCMD_GET_TASK); //send only ever X (1000) checks...
   application.processmessages;
    
   inc(i);
   if iData.Count>0 then //incomed message
    for j:=iData.Count-1 downto 0 do
     if assigned(iData.Items[j]) then
      if iData_p(iData.Items[j])^.count>0 then
      begin
       if iData_p(iData.Items[j])^.buf^.cmd = NCMD_TASK_4U then
        begin //got task
         current_task := true;
         task_iFrom := iData_p(iData.Items[j])^.buf^.dw1;
         task_iTo := iData_p(iData.Items[j])^.buf^.dw2;
         if task_iTo < task_iFrom then
          begin
           current_task:=false;
           memo1.lines.add('Got invalid task description, wait for another...');
           SendSimpleCommand(NCMD_GOT_INVALID_TASK);
          end else
           goto have_task;
        end;
       if iData_p(iData.Items[j])^.buf^.cmd = NCMD_BREAK then
        memo1.lines.add('Got BREAK COMMAND'); //TODO : exit
       if iData_p(iData.Items[j])^.buf^.cmd = NCMD_ALL_DONE then
        begin
         memo1.lines.add('Got ALL DONE COMMAND');
         label3.caption:='Server said, that :all done:';
         exit;
        end;
      end;
   application.processmessages; //so data can be incomed
   
   if current_task = true then
    break;
  Until (application.terminated) or (Connected = false);

have_task:
 application.processmessages;
 

(*
 //clear iData
   if iData.Count>0 then //incomed message
    for j:=iData.Count-1 downto 0 do
     if assigned(iData.Items[j]) then
      iData_p(iData.Items[j])^.buf^.cmd = any_cmd then
       dispose(iData.Items[j]);
*)

  if current_task then
  begin
    //do the task
    memo1.lines.add('COMPUTING TASK <'+IntToStr(task_iFrom)+';'+IntToStr(task_iTo)+'> ...');
    Label3.Caption:='Computing given task...';
    task_position := task_iFrom;
    label8.caption:='0 PN(s)';
    memo2.Clear; Label6.Caption:='-NA-';
    //
    UpgradeGUI;
    NumPrimes:=0;
    for j := task_iFrom to task_iTo do
    begin
     task_position := j;

     IsPrime := _13_IsItPrimeNum(task_position);
     LastPrime := task_position;
     If IsPrime then
     begin
      Label6.Caption := IntToStr(LastPrime);
      memo2.text:=memo2.text + ' '+IntToStr(LastPrime);

      application.processmessages;

      SendDWCommand(NCMD_GOT_ONE, LastPrime, task_position);
      sendbig;
      application.processmessages;

      sleep(1);

      label8.caption:=inttostr(NumPrimes+1)+' PN(s)';
      AllPrimes[NumPrimes]:=LastPrime;
      inc(NumPrimes);
     end;
     UpgradeGUI;
     //TODO: here should i check for NCMD_BREAK
     //      and for Connected = false

    end;
     //send
     Label3.Caption := 'Given task DONE';

     SendPrimes;


    //TODO: now should i send all results for my task to server
    //but if no packet of NCMD_GOT_ONE is lost, i needn't do it.
    //- therefor it is "TODO"

//    SendSimpleCommand(NCMD_ALL_DONE);
    application.processmessages;

  end;

 Until (application.terminated) or (Connected = false);
end;



procedure TForm1.CS1Read(Sender: TObject; Socket: TCustomWinSocket);
var //l    : integer;
    buf  : pointer;
    iDta : iData_p;
    s    : string;
    l    : integer;
begin
 //receive
// l := socket.ReceiveLength;
// memo1.lines.add('Length: '+inttostr(l));
// if l = 0 then exit;
// getmem(buf, l);
// socket.ReceiveBuf(buf^, l);

 s:=socket.ReceiveText;
 getmem(buf, length(s));
 move(s[1], buf^, length(s));
 //add to cmd list
 new(iDta);
 iDta.buf := buf;
 iDta.count := length(s);
 iData.Add(iDta);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 ClearList(iData);
 iData.Free;
end;

procedure TForm1.CS1Error(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
 memo1.lines.add('WinSock Error: '+inttostr(errorcode));
end;

end.
