unit _13_Server_Form1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ScktComp, ComCtrls, Math;

const
  WM_START_SERVER_PROCESSING = WM_USER + $FB;

  NCMD_NONE          = 0; //nope
  NCMD_GET_TASK      = 1; //client want new task
  NCMD_DISCONNECTED  = 2; //user stops client
  NCMD_GOT_ONE       = 3; //prime found
  NCMD_TASK_DONE     = 4; //all numbers in task checked
  NCMD_TASK_4U       = 5; //sending task for client
  NCMD_BREAK         = 6; //server stopped
  NCMD_ALL_DONE      = 7; //all done, no more help from client is needed

  NCMD_GOT_INVALID_TASK = 8; //got invalid task, i wanna new

type
  Client_p = ^ client_t;
  TClientStatus = (cliDoNothing, cliComputing, cliError);

  client_t = record
                  id_no      : dword;
                  socket     : TCustomWinSocket;
                  listitem   : TListItem;
                  //
                  status     : TClientStatus;
                  ifrom, ito : dword; //interval
                  position   : dword; //progress
                 end;

  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Panel1: TPanel;
    Button1: TButton;
    Label2: TLabel;
    Label3: TLabel;
    ListView1: TListView;
    Memo1: TMemo;
    SS1: TServerSocket;
    Button2: TButton;
    Button3: TButton;
    procedure Edit1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SS1ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure SS1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SS1ClientWrite(Sender: TObject; Socket: TCustomWinSocket);
    procedure SS1ClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
//    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateGUI;
    procedure OnStartServerProcessing(var Msg:TMessage); message WM_START_SERVER_PROCESSING;
    procedure SendDWCommand(client:client_p; cmd : byte; dw1, dw2 : dword);
    procedure SendSimpleCommand(client:client_p; cmd : byte);    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

CONST
  start_from   = 0;
  start_to     = 2147483647; //2^31 - 1;

implementation

uses _13_Server_Form2;

{$R *.DFM}

type
      Inter_p = ^inter_t;
      Inter_t = record
                 ifrom : dword;
                 ito   : dword;
                end;

CONST MAXDATA = 1013;
      MY_ID = 1234;

type DataBuffer_t = packed record
                     id   : word;
                     cmd  : byte;
                     dw1, dw2 : dword;
                     data : packed array[0..MAXDATA] of byte;
                    end;
     DataBuffer_p = ^DataBuffer_t;

type iData_p = ^iData_t;
     iData_t = record
                client : client_p;
                buf    : DataBuffer_p;
                count  : word;
               end;

var
  iData         : TList; //buffer for incomed data
  ClientList    : TList; //all clients (Client_t)
  NotDoneInt    : TList; //not done intervals (to be computed) (Inter_t)

  LastIDno      : DWORD; //last ID number assigned to client

  Server_Processing : Boolean; 

// LISTS

procedure ClearList(x:TList);
var i:integer;
begin
 if assigned(x)=false then
  exit;
 if x.count<1 then
  exit;
 for i:=0 to x.count-1 do
  if assigned(x.items[i]) then
   begin
    dispose(x.items[i]);
//    x.items[i]:=nil;
   end;
 x.clear;
end;

procedure AddToClientList(newitem : Client_p);
begin
 if not assigned(ClientList) then
  begin ClientList:=TList.Create;ClientList.clear;end;
 ClientList.Add(newitem);
 ClientList.Pack; //delete all nil items
end;

function FindClient(socket : TCustomWinSocket):Client_p;overload;
var i : integer;
begin //find client, if we know "socket"
 Result := nil;
 if (not assigned(ClientList))or(ClientList.Count<1) then
  exit;
 For i:=0 to ClientList.Count-1 do
  if Assigned(ClientList.items[i]) then
   if Client_p(ClientList.items[i])^.socket = socket then
    begin result := ClientList.items[i]; exit; end;
end;


//
function GetClientIDno : dword;
begin  //now simply inc, don't bother with any alg. to assign ID numbers
 inc(lastIDno);
 result := lastIDno;
end;

//intervals
var nr : boolean = true; //indicates end
    last_int : dword = 0;

Function AssignInterval(var iFrom : dword; var iTo : dword) : boolean;
 //returns:
 // iFrom, iTo - interval to be computed by asking client
 // result =true - if any not computed interval found
begin
 result:=nr;
 iFrom:=last_int;
 iTo:=min(start_to,last_int+1000);
 if last_int > start_to - 1000 then
  nr:=false;
 inc(last_int,1000);

 //----not done because of time---- 
end;

Procedure AddNotDoneInterval(iFrom, iTo : dword);
 //add <iFrom;iTo> to global intervals list
 //and "pack" this list (ie. make union of some intervals, if it can be done)
begin
 // first, look if <iFrom, iTo> is in any known interval
 // then look, if iFrom is in any interval same as its iFrom
 // then look for iTo
 // else add new interval <iFrom, iTo>

 //----not done because of time----
end;


Procedure ItervalDoneForClient(Client : client_p);
begin
 //client have done all of his interval
 //modify NotDoneInt list

 //----not done because of time----
end;

// GUI, ...

procedure TForm1.UpdateGUI;
var i      : integer;
    client : client_p;
begin
 //update ListView1, Label3, ...
 ClientList.Pack;
 Label3.Caption := IntToStr(ClientList.Count);
 //
 if ClientList.Count>0 then
  for i:=0 to ClientList.Count-1 do
   if assigned(ClientList.Items[i]) then
    begin
     client:=ClientList.Items[i];
     if assigned(client.listitem) then
      with client.listitem do begin
       if client.status = cliDoNothing then
        begin SubItems[1]:='-NA-'; SubItems[2]:='-NA-'; end else
        begin
         SubItems[1]:=IntToStr(client.iFrom);
         SubItems[2]:=IntToStr(client.iTo);
        end;
       //compute % progress (100/max * pos)
       if (client.Position = 0)and(client.iFrom>0) then
       begin
        if client.iTo-client.iFrom <>0 then
         SubItems[3]:=format('%0.2f %%',[(100/(client.iTo-client.iFrom)) * (client.position - client.iFrom)]);
       end else
        SubItems[3]:='0 %'; //client did't send me his progress yet  
       case client.status of
        cliDoNothing : SubItems[4]:= 'No task assigned';
        cliComputing : SubItems[4]:= 'Computing ...';
        cliError     : SubItems[4]:= 'Error occured!';
       end;    
      end;
    end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 ClearList(NotDoneInt); NotDoneInt.free;
 ClearList(iData); iData.free;
 ClearList(ClientList); ClientList.Free; 
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 ClientList := TList.Create; ClientList.Clear;
 NotDoneInt := TList.Create; NotDoneInt.Clear;
 iData := TList.Create; iData.Clear;

 AddNotDoneInterval ( start_from, start_to );

 Server_Processing := false;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 try
  StrToInt(edit1.text);
  button1.enabled:=true; //if there is a number, button can be enabled
 except
  button1.enabled:=false; //or no
 end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 Edit1Change(nil); //allow Button1
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 try
  SS1.Port:=StrToInt(edit1.text);
 except messagebeep(0);exit;end;
 SS1.open;
end;

procedure TForm1.SS1ClientError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
 memo1.lines.add('Client error: '+IntToStr(ErrorCode));
end;

procedure TForm1.SS1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);

var Client : Client_p;
begin
 //
 new(client);
// fillchar(client^,sizeof(client_t),0);
 client.id_no := GetClientIDno;
 client.socket := Socket;
 //create listview item
 client.listitem := ListView1.Items.Add;
 client.listitem.Caption := IntToStr(client.id_no);
 client.status:=cliDoNothing;
 with client.listitem do
 begin
  SubItems.Add(client.socket.RemoteAddress);
  SubItems.Add('-NA-');
  SubItems.Add('-NA-');
  SubItems.Add('0 %');
  SubItems.Add('No task assigned');
 end;
 //store
 AddToClientList(client);
 //update GUI
 ClientList.Pack;
 Label3.Caption := IntToStr(ClientList.Count);
 //LOG
 memo1.Lines.add('CLIENT CONNECTED');
// socket.sendtext('ahoj kliente');

 if not Server_Processing then
  PostMessage(Form1.Handle, WM_START_SERVER_PROCESSING, 0, 0);
// timer1.enabled:=true;
end;

procedure TForm1.SS1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);

var Client : Client_p;
begin
 //LOG
 memo1.Lines.add('CLIENT DISCONNECTED');
 Client := FindClient(Socket);
 if not assigned(Client) then
  begin memo1.Lines.add(' -- IT WAS UNKNOWN CLIENT');exit;end;
 if assigned(Client.ListItem) then
  Client.ListItem.Delete;
 ListView1.Repaint; 
 //update list
 ClientList.Remove(Client);
 ClientList.Pack;
 //GUI
 UpdateGUI;
end;

procedure TForm1.SendSimpleCommand(client:client_p; cmd : byte);
var buf : DataBuffer_t;
    s   : string;
begin
 fillchar(buf, sizeof(buf), 0);
 buf.id := MY_ID;
 buf.cmd := cmd;
 try
  setlength(s, 512);
  move(buf, s[1], 3);
  client.socket.SendText(s);
// client.socket.sendbuf(buf, 1000);
 except
  memo1.lines.add('SendSimpleCommand - WSOCK err');
 end;
end;

procedure TForm1.SendDWCommand(client:client_p; cmd : byte; dw1, dw2 : dword);
var buf : DataBuffer_t;
    s   : string;
begin
 fillchar(buf, sizeof(buf), 0);
 buf.id := MY_ID;
 buf.cmd := cmd;
 buf.dw1 := dw1;
 buf.dw2 := dw2;
 try
  setlength(s, 512);
  move(buf, s[1], 11);
  client.socket.SendText(s);

//  client.Socket.sendbuf(buf,1000);
 except
  memo1.lines.add('SendDWCommand - WSOCK err');
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 SS1.Close;
 Edit1change(nil); //test edit1.text
 UpdateGUI;
end;


procedure TForm1.SS1ClientWrite(Sender: TObject; Socket: TCustomWinSocket);
var client : client_p;
    l      : integer;
    buf    : pointer;
    iDta   : iData_p;
    s      : string;
begin
 client := FindClient(Socket);
 if not assigned(client) then
  begin
   memo1.lines.add('ERR: unknown client wrote data');
//    if socket.ReceiveLength > 0 then
//     it should be received and thrown
  end else
  begin
   memo1.lines.add('Client '+inttostr(client.id_no)+' wrote data');
   ;
   //receive
//   l := socket.ReceiveLength;
//   memo1.lines.add('Length: '+inttostr(l));
//   if l = 0 then //exit;
//    l := sizeof(databuffer_t);
//   getmem(buf, l);
//   socket.ReceiveBuf(buf^, l);

   s:=socket.ReceiveText;
   getmem(buf, length(s));
   move(s[1], buf^, length(s));

   //add to cmd list
   new(iDta);
   iDta.client:=client;
   iDta.buf := buf;
   iDta.count := length(s);
   iData.Add(iDta);
  end;
end;

procedure TForm1.OnStartServerProcessing(var Msg:TMessage);
var nmsg    : iData_p;
    i       : integer;
    iFrom,
    iTo     : dword;
    client  : client_p;
begin
 Server_Processing := true;
 repeat
  application.processmessages;
  application.handlemessage;
  if iData.Count >0 then
   begin //handle incomed message
    nmsg := iData.Items[iData.Count-1];
    //check, if nmsg is OK
    if not assigned(nmsg) then
     begin
      iData.pack;
      continue;
     end;
    if not assigned(iData_p(nmsg)^.buf) then
     begin
      iData.Remove(nmsg);
      dispose(nmsg);
      continue;
     end;
    if iData_p(nmsg)^.count<1 then
     begin
      iData.Remove(nmsg);
      try freemem(iData_p(nmsg)^.buf);except end;
      dispose(nmsg); continue;
     end;
     //and now: handle it
     client:=nmsg.Client;
     
     case nmsg.buf.cmd of
      NCMD_GET_TASK :
       if assigned(client) then
       begin
        if AssignInterval(iFrom, iTo) then
         begin
          client.status := cliComputing;
          client.position := 0; //now nothing done
          client.iFrom := iFrom;
          client.iTo := iTo;
          memo1.lines.add('sending ans');
          for i:= 1 to 3 do //send it THREE times, so it must be delivered
          begin
           SendDWCommand(client, NCMD_TASK_4U, iFrom, iTo);
           application.processmessages;
           application.handlemessage;           
           sleep(1);
          end;
         end else
          SendSimpleCommand(client, NCMD_ALL_DONE);
       end;

       NCMD_GOT_ONE:
        begin
//         memo1.lines.add(inttostr(nmsg.buf.dw1));
         client.position:=nmsg.buf.dw2;
        end;

       NCMD_TASK_DONE:
        begin
         //got primes (in buf.data)
          //----not done because of time----

         memo1.lines.add('Got NCMD_TASK_DONE'); 
         ItervalDoneForClient(Client);
        end;

       NCMD_NONE:
        begin
         memo1.lines.add('NOPE');
        end;
       //OTHER COMMANDS:
         //----not done because of time---- 
     end; //case
     //remove CMD
     iData.Remove(nmsg);
     try
      if assigned(nmsg.buf) then
       freemem(nmsg.buf);
     except end;
     try Dispose(nmsg);except end;
     //GUI
     UpdateGUI;
   end;
 until application.terminated;

 Server_Processing := false; 
end;




procedure TForm1.Button3Click(Sender: TObject);
begin
 form2.updateitems;
 form2.show;
end;

{
procedure TForm1.Timer1Timer(Sender: TObject);
var msg:tmessage;
begin
 timer1.enabled:=false;
 OnStartServerProcessing(Msg);
end;
}
end.
